#ifndef EFL_UI_ZOOMABLE_EO_HH
#define EFL_UI_ZOOMABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_zoomable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Zoomable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Zoomable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace ui { 
struct Zoomable {
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_ZOOMABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Zoomable() const;
   operator ::efl::ui::Zoomable&();
   operator ::efl::ui::Zoomable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Zoomable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Zoomable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Zoomable : ::efl::eo::concrete
{
   explicit Zoomable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Zoomable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Zoomable(Zoomable const& other) = default;
   Zoomable(Zoomable&& other) = default;
   Zoomable& operator=(Zoomable const& other) = default;
   Zoomable& operator=(Zoomable&& other) = default;
   Zoomable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Zoomable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Zoomable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_ZOOMABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct zoom_start_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_ZOOM_START; }
      typedef void parameter_type;
   } const zoom_start_event;
   static struct zoom_stop_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_ZOOM_STOP; }
      typedef void parameter_type;
   } const zoom_stop_event;
   static struct zoom_change_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_ZOOM_CHANGE; }
      typedef void parameter_type;
   } const zoom_change_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Zoomable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Zoomable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Zoomable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Zoomable>::value, "");
} } 
#include "efl_ui_zoomable.eo.impl.hh"
#endif
